"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class StandardPhenotype(ProtocolElement):
    """
    Standard phenotype term based on the OBO format (see an example here
    http://snapshot.geneontology.org/ontology/go-basic.obo)
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "ontology",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import reports as reports_6_1_0

        return {
            "ontology": reports_6_1_0.Ontology,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_4 import reports as reports_6_1_0

        return {
            "org.gel.models.report.avro.Ontology": reports_6_1_0.Ontology,
            "org.gel.models.report.avro.StandardPhenotype": reports_6_1_0.StandardPhenotype,
        }

    __slots__ = [
        "id",
        "ontology",
        "alternativeIds",
        "comment",
        "definition",
        "isA",
        "matchScore",
        "name",
        "namespace",
        "synonyms",
    ]

    def __init__(
        self,
        id,
        ontology,
        alternativeIds=None,
        comment=None,
        definition=None,
        isA=None,
        matchScore=None,
        name=None,
        namespace=None,
        synonyms=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_1_0.StandardPhenotype model.

        :param id:
        :type id: str
        :param ontology:
            The ontology (e.g.: HPO, OMIM, SNOMED CT)
        :type ontology: Ontology
        :param alternativeIds:
        :type alternativeIds: None | str
        :param comment:
        :type comment: None | str
        :param definition:
        :type definition: None | str
        :param isA:
        :type isA: None | str
        :param matchScore:
            The match between the non standard phenotype and this term when in
            silico
        :type matchScore: None | float
        :param name:
        :type name: None | str
        :param namespace:
        :type namespace: None | str
        :param synonyms:
        :type synonyms: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.1.0"
